<<* MSAFORM.INC *>>
<<#

<<* MODIFIED R. BORTER, JR *>>

procedure WriteLabels
integer lasthue
begin
  lasthue := 32000
  forall fields
    if (fldhue <> lasthue)
      genln( 'SET COLOR TO ',AtrCode( fldhue ) )
      lasthue := fldhue
    endif
    genLABEL
  endfor
end <<*WriteLabels*>>


procedure GenFormBody
begin
  select all    <<*View all fields in the table*>>
  if ismultipage
    genln( 'DO CASE' )
    forall pages
      if fldtotal > 0
        genln( 'CASE pageno=',pagcount )
        pushmargin( 1 )
        WriteLabels
        popmargin
      endif
    endfor
    genln( 'ENDCASE' )
  else  <<*Single page format*>>
    select page 1
    WriteLabels
  endif
end <<*GenFormBody*>>


procedure GenFormHead
begin
  GenColor( 0,'SCREEN' )
  genln( 'CLEAR' )
  GenColor( 0,'STATUS' )
#>>
@  0, 0 SAY SPACE(80)
STORE DATE4(DATE()) TO SYSDATE
@ 0,1 SAY SPACE(78-LEN(SYSDATE))+SYSDATE
*@  0, 0 SAY "Record:"
<<if ismultipage>>
@  0,17 SAY "Page:"
<<endif>>
<<GenColor( 0,'PROMPT' )>>
@ PromptRow-1,0 SAY PromptBar
*
<<end>> <<*GenFormHead*>>

<<* EOF: MSAFORM.INC *>>
