<<* MSAINST.INC *>>
<< PROCEDURE geninstall>>

<<begin>>
SET SAFETY OFF
?? SYS(2002,1)
memfile = {"}{fileprefix}"+"_INST.MEM"
IF .NOT. FILE(memfile)
   STORE SPACE(15) TO inst_c1,inst_c2,inst_c3,inst_c4,inst_c5
   STORE SPACE(30) TO inst_l_off,inst_l_on,inst_bak,inst_inc
   STORE SPACE(30) TO inst_c_off,inst_c_on,inst_e_off,inst_e_on
   STORE SPACE(30) TO inst_rest
   STORE SPACE(3) TO inst_code
   STORE SPACE(1) TO inst_drive
   CLEAR
   <<shade>>
   @ 22,0 SAY REPLICATE( CHR(219),80 )
   @ 23,59 SAY "F1 = Help/Utilities"
ENDI 
DO WHILE .T.
   @ 8,14,15,50 box ''
   @ 8,14,15,50 box "͸Գ"
   @ 10,16 SAY '        Enter Company Name: '
   @ 11,18 GET inst_inc
   @ 13,19 SAY 'Enter Facility Ext. Code: ' GET inst_code PICT '!!!'
   READ
   STORE ' ' TO check
   @ 24,0 CLEAR
   @ 24,0 SAY 'All entries correct ? (Y/N)'GET check  PICT '!' valid;
     check$'YN'
   READ
   IF check = 'Y'
      EXIT
   ELSE
      LOOP
   ENDI 
ENDD 
<<shade>>
@ 24,0 CLEAR
@ 24,0 SAY 'Program to set printer defaults. '
STORE inst_c_on +SPACE(30-LEN(inst_c_on)) TO inst_c_on
STORE inst_c_off+SPACE(30-LEN(inst_c_off)) TO inst_c_off
STORE inst_l_on +SPACE(30-LEN(inst_l_on)) TO inst_l_on
STORE inst_l_off+SPACE(30-LEN(inst_l_off)) TO inst_l_off
STORE inst_e_on +SPACE(30-LEN(inst_e_on)) TO inst_e_on
STORE inst_e_off+SPACE(30-LEN(inst_e_off)) TO inst_e_off
DO WHILE .T.
   @ 24,0 CLEAR
   @ 24,0 SAY 'Enter Corresponding Escape Codes.'
   @ 16,20,18,60 box ''
   @ 16,20,18,60 box "͸Գ"
   @ 17,30 SAY 'EXAMPLE: CHR(27)+"*1"'
   @ 5,12,14,68 box ''
   @ 5,12,14,68 box "͸Գ"
   @  7,17 SAY 'Letter Quality ON: ' GET inst_l_on
   @  8,17 SAY '         Draft ON: ' GET inst_l_off
   @  9,17 SAY '      Condense ON: ' GET inst_c_on
   @ 10,17 SAY '     Condense OFF: ' GET inst_c_off
   @ 11,17 SAY '     Elongated ON: ' GET inst_e_on
   @ 12,17 SAY '    Elongated OFF: ' GET inst_e_off
   READ
   STORE ' ' TO check
   @ 24,0 CLEAR
   @ 24,0 SAY 'Are all entries correct ? (Y/N) ' get;
   check PICT '!' valid check$'YN'
   READ
   IF check = 'Y'
      EXIT
   ENDI 
ENDD
* INSTALL COLORS
STORE ' ' TO check
?? CHR(7)
@ 24,0 CLEAR
@ 24,0 SAY 'Do you wish to install the default colors ?'+' (Y/N) ' GET;
 check  PICT '!' valid check$'YN'
READ
IF check = 'Y'
   STORE {"}{screencolor}" TO inst_c1,screenatr
   STORE {"}{statuscolor}" TO inst_c2,statusatr
   STORE {"}{windowcolor}" TO inst_c3,windowatr
   STORE {"}{promptcolor}" TO inst_c4,promptatr
   STORE {"}{hilitecolor}" TO inst_c5,hiliteatr
ELSE
   ****************************
   **  LISTING THE COLORS  ****
   ****************************
   <<shade>>
   STORE SPACE(15) TO statusatr,windowatr,promptatr,hiliteatr
   DO WHILE .T.
      SET COLOR TO
      @ 5,5,18,64 box ''
      @ 5,5,18,64 box "͸Գ"
      SET COLOR TO &INST_C2
      @ 7,7 SAY 'Status Color: '+ inst_c2+' 'GET inst_c2
      SET COLOR TO &INST_C3
      @ 10,7 SAY 'Window Color: '+inst_c3+' 'GET inst_c3
      SET COLOR TO &INST_C4
      @ 13,7 SAY 'Prompt Color: '+inst_c4+' 'GET inst_c4
      SET COLOR TO &INST_C5
      @ 16,7 SAY 'Hilite Color: '+inst_c5+' 'GET inst_c5
      CLEAR GETS
      SET COLOR TO W/B,N/W
      @ 3,49 CLEAR TO 16,63
      @ 3,49 TO 16,63
      @  4,50 SAY 'COLOR    CODE'
      @  5,50 SAY ''
      @  6,50 SAY 'Black     N  '
      @  7,50 SAY 'Blank     X  '
      @  8,50 SAY 'Blue      B  '
      @  9,50 SAY 'Brown     GR '
      @ 10,50 SAY 'Cyan      BG '
      @ 11,50 SAY 'Green     G  '
      @ 12,50 SAY 'Magenta   RB '
      @ 13,50 SAY 'Red       R  '
      @ 14,50 SAY 'White     W  '
      @ 15,50 SAY 'Yellow    GR+'
      @ 8,7 SAY 'New setting: ' GET statusatr
      @ 11,7 SAY 'New setting: ' GET windowatr
      @ 14,7 SAY 'New setting: ' GET promptatr
      @ 17,7 SAY 'New setting: ' GET hiliteatr
      READ
      STORE ' ' TO check
      @ 24,0 CLEAR
      @ 24,0 SAY 'All entries correct ? (Y/N)'GET check PICTURE '!' valid;
        check$'YN'
      READ
      IF check = 'Y'
         STORE statusatr TO inst_c2
         STORE windowatr TO inst_c3
         STORE promptatr TO inst_c4
         STORE hiliteatr TO inst_c5
         EXIT
      ELSE
         LOOP
      ENDI 
   ENDD (NEW COLOR) 
ENDI (COLOR SECTION) 

* ---DRIVE SPEC, & BACK UP FILES
SET COLOR TO &SCREENATR
@ 1,0 CLEAR
<<shade>>
<<GenColor( 0,'HILITE' )>>
STORE DATE4(DATE()) TO SYSDATE
@ 22,0 SAY SPACE(80)   &&CLEAR LINE
@ 22,1 SAY INST_INC+SPACE(48-LEN(SYSDATE))+SYSDATE
<<GenColor( 0,'SCREEN' )>>
@ 8,14,16,76 box ''
@ 8,14,16,76 box "͸Գ"
@ 10,30 SAY ' Enter data drive: ' GET inst_drive PICT '!'
@ 12,15 SAY ' Enter Back-UP Program Name: ' GET inst_bak PICT '@!'
@ 14,15 SAY ' Enter Restore Program Name: ' GET inst_rest PICT '@!'
READ
@ 24,0 CLEAR
@ 24,0 SAY 'Saving set up.'
SAVE TO {fileprefix}_inst.mem ALL LIKE inst_*
?? SYS(2002)
**
**
<<end>>
<<* MSAINST.INC *>>
