<<* MSAMENU.INC *>>
<<* Modified 5 May 1988 *>>

<<#

function ExpandName( name : string ) : string
string  strg
integer cp,namelen,count
begin
  cp := 1
  namelen := len( name )
  strg := replicate( ' ',80 )
  for count := 1 to namelen   <<*E-X-P-A-N-D the string*>>
    strg[ cp ] := name[ count ]
    cp := cp + 2
  end
  strg[0] := chr( namelen * 2 - 1 )  <<*Assign the new string length*>>
  RETURN strg
end ExpandName


procedure GenMenuStatus
string line
integer col
begin
  forall databases
    filespec( dbfnam,fpath,fname,fext )
    line := line + fname + space( 8 - len(fname) )
  endfor
#>>
@  0, 0 SAY {"}{line}{"}
@  0,72 SAY DATE()
DO CASE
<<forall databases>>
CASE dbfarea = {"}{dbfcount}{"}
  <<col := (dbfcount - 1) * 8>>
  <<GenColor( 1,'HILITE' )>>
  <<filespec( dbfnam,fpath,fname,fext )>>
  <<fname := fname + space( 8 - len(fname) )>>
   @ 0,{col} SAY {"}{fname}{"}
<<endfor>>
ENDCASE
<<GenColor( 0,'SCREEN' )>>
<<end GenMenuStatus>>


<<procedure GenSingleLiteBar>>
<<begin>>
PARAMETER CHOICE_X,CHOICE_Y
PUBLIC menuhdg
<<fname := ExpandName( menutitle )>>
menuhdg = {"}{fname}{"}
<<Gencolor( 0,'SCREEN' )>>
@ 0,0 CLEAR
<<Shade>>
DO PromptBar
@ 23,59 SAY "F1 = Help/Utilities"
DIMENSION M_MAIN(6,2)
M_MAIN(1,1) = 'File'
M_MAIN(1,2) = 'File Operations '
M_MAIN(2,1) = 'Reports'
M_MAIN(2,2) = 'Selected Reports'
M_MAIN(3,1) = 'Label'
M_MAIN(3,2) = 'Selected Labels'
M_MAIN(4,1) = 'Misc.'
M_MAIN(4,2) = 'Miscellaneous Procedures'
M_MAIN(5,1) = 'Backup'
M_MAIN(5,2) = 'Backup and Restore files'
M_MAIN(6,1) = 'Quit'
M_MAIN(6,2) = 'Exit Program'
Menu Bar M_MAIN,6

Dimension M_FILE(6)
M_FILE(1) = 'Add records'
M_FILE(2) = 'Edit records'
M_FILE(3) = '\-'
M_FILE(4) = 'Browse'
M_FILE(5) = 'Index & Pack'
M_FILE(6) = 'Export'

Menu 1,M_FILE,6

Dimension M_REPO(5)
M_REPO(1) = 'View Deleted Records'
M_REPO(2) = 'Run Report Form'
M_REPO(3) = 'Create Report'
M_REPO(4) = 'Add in Report #4'
M_REPO(5) = 'Add in Report #5'

Menu 2,M_REPO,5

Dimension M_LABE(4)
M_LABE(1) = 'Run Labels'
M_LABE(2) = 'Create Label Form'
M_LABE(3) = 'Add in Label #3'
M_LABE(4) = 'Add in Label #4'

Menu 3,M_LABE,4

Dimension M_MISC(4)
M_MISC(1) = 'Install System'
M_MISC(2) = 'System Documentation'
M_MISC(3) = 'Add in Routine #3'
M_MISC(4) = 'Add in Routine #4'

Menu 4,M_MISC,4

Dimension M_BACK(3)
M_BACK(1) = 'Backup Database Files'
M_BACK(2) = 'Restore Database Files'
M_BACK(3) = 'Archive Deleted Files'

Menu 5,M_BACK,3

Dimension M_QUIT(2)
M_QUIT(1) = 'Exit Program'
M_QUIT(2) = 'Run External Program'

Menu 6,M_QUIT,2

Read menu bar to CHOICE_X,CHOICE_Y save
* ---release arrays
RELEASE ALL LIKE M_*
<<end GenSingleLiteBar>>


<<procedure GenMultiLiteBar>>
<<begin>>
PARAMETER CHOICE_X,CHOICE_Y
<<Gencolor( 0,'SCREEN' )>>
@ 0,0 CLEAR
<<Shade>>
<<GenColor( 0,'HILITE' )>>
STORE DATE4(DATE()) TO SYSDATE
@ 22,0 SAY SPACE(80)   &&CLEAR LINE
@ 22,1 SAY INST_INC+SPACE(48-LEN(SYSDATE))+SYSDATE
* ---Center the menu heading.
<<fname := ExpandName( menutitle )>>
menuhdg = {"}{fname}{"}
col = (80 - LEN(menuhdg)) / 2
@  22,col SAY menuhdg
<<Gencolor( 0,'SCREEN' )>>
@ 23,59 SAY "F1 = Help/Utilities"
DIMENSION M_MAIN(6,2)
M_MAIN(1,1) = 'File'
M_MAIN(1,2) = 'File Operations '
M_MAIN(2,1) = 'Reports'
M_MAIN(2,2) = 'Selected Reports'
M_MAIN(3,1) = 'Label'
M_MAIN(3,2) = 'Selected Labels'
M_MAIN(4,1) = 'Misc.'
M_MAIN(4,2) = 'Miscellaneous Procedures'
M_MAIN(5,1) = 'Backup'
M_MAIN(5,2) = 'Backup and Restore files'
M_MAIN(6,1) = 'Quit'
M_MAIN(6,2) = 'Exit Program'
Menu Bar M_MAIN,6

Dimension M_FILE(8)
M_FILE(1) = 'Add records'
M_FILE(2) = 'Edit records'
M_FILE(3) = '\-'
M_FILE(4) = 'Browse'
M_FILE(5) = 'Index & Pack'
M_FILE(6) = 'Export'
M_FILE(7) = '\-'
M_FILE(8) = 'Select File'
Menu 1,M_FILE,8

Dimension M_REPO(5)
M_REPO(1) = 'View Deleted Records'
M_REPO(2) = 'Run Report Form'
M_REPO(3) = 'Create Report'
M_REPO(4) = 'Add in Report #4'
M_REPO(5) = 'Add in Report #5'

Menu 2,M_REPO,5

Dimension M_LABE(4)
M_LABE(1) = 'Run Labels'
M_LABE(2) = 'Create Label Form'
M_LABE(3) = 'Add in Label #3'
M_LABE(4) = 'Add in Label #4'

Menu 3,M_LABE,4

Dimension M_MISC(4)
M_MISC(1) = 'Install System'
M_MISC(2) = 'System Documentation'
M_MISC(3) = 'Add in Routine #3'
M_MISC(4) = 'Add in Routine #4'

Menu 4,M_MISC,4

Dimension M_BACK(3)
M_BACK(1) = 'Backup Database Files'
M_BACK(2) = 'Restore Database Files'
M_BACK(3) = 'Archive Deleted Files'

Menu 5,M_BACK,3

Dimension M_QUIT(2)
M_QUIT(1) = 'Exit Program'
M_QUIT(2) = 'Run External Program'

Menu 6,M_QUIT,2

Read menu bar to CHOICE_X,CHOICE_Y save
* ---release arrays
RELEASE ALL LIKE M_*
<<end GenMultiLiteBar>>


<<#
procedure GenLiteBarMenu
begin
  if ismultials
    GenMultiLiteBar
  else
    GenSingleLiteBar
  endif
end GenLiteBarMenu
#>>


<<* EOF: MSAMENU.INC *>>
