<<* MSAREAD.INC *>>

<<procedure GenReadBody>>
<<begin>>
                         MSA_1 TEMPLATES
        COPYRIGHT (C) 1987-1988 BY MicroSearch Associates.
                  ALL RIGHTS RESERVED WORLDWIDE

          FOR USE WITH FOXVIEW/VIEWGEN PROGRAM GENERATOR 
                 ON IBM COMPUTERS AND COMPATABLES

          This README file contains the system notes and
                       SOFTWARE AGREEMENT.




USE CTRL-S TO STOP AND START THE SCROLLING PROCESS AS YOU READ
THIS FILE.

You may print this file by using either PRINT.COM (a DOS
utility), your text processor, or use the DOS COPY command as
follows:

              A>COPY README.TXT PRN <ENTER>

___________________________________________________________________________
Viewgen is a registered trademark of Software Tools, Inc.
FoxBASE+ is a registered trademark of Fox Software
IBM is a registered trademark of International Business Machines
Corp.


                           INTRODUCTION

Thank you for taking time to examine the MSA_1 templates. The
template and source code are distributed as shareware (see
SOFTWARE AGREEMENT at the end of this document).  Registration
allows continued enhancement of the system and thereby saves all
of us time when developing systems.  The code is based on the
original APPS1 template written by Louis Castro, the creator of
Viewgen.  A large portion of the original system has been
rewritten.

Special features of the file system include:

	 - Use of latest Foxbase+ 2.10 commands.
	 - "Pull-down" and "Pop-up" menus.
	 - "Pop-up" calendar.
	 - User-defined installation.
	 - Directory searches.
	 - Backup and restore option.
	 - Ability to "RUN" external programs.


Wherever possible, the new commands and features of FOXBASE+
have been implemented to demonstrate their use.  The programs
provide a "MAC"-like interface for the generated programs, which
has become one of the more popular interfaces.  Due to time
constraints, not all features (such as the "pop-up" calculator,
Export and help system) are available and there are a number of
enhancements yet to be made.  Registration will insure that you
receive timely notification of future updates of these templates.

Any suggestions you may have to improve the system are
appreciated.


                           SYSTEM NOTES

GENERAL

SAMPLE APPLICATION USE:  Included with the templates and their
source code is a sample application.  The files SAMPLE.FV,
SAMPLE.CFG and SAMPLE.DBF can be used to "try-out" the templates
and FOXVIEW. 

To run the templates with the sample application you must first
execute the FoxView program.  Press <Esc> once in FoxView to
activate the pull down menus and select the LOAD menu section.  

The configuration file is loaded separately by selecting the New
Config option.  The CFG file can also be renamed FoxView.CFG
(VIEWGEN.CFG if you are using a copy of VIEWGEN) after which it
will be automatically loaded in each time the FoxView is run. 
This configuration file has the default screen colors set to
white on blue, which is the setting used when designing the
sample template.  As you become familiar with the system the
colors can be changed to reflect your own preferences.  

The FoxView table SAMPLE.FV file must also be loaded by selecting
the Load Table option and entering "Sample".  

To generate code move to the GEN menu and select Template Prgs. 
FoxView will display a directory of templates.  Select MSA_1
template.  (If not listed check the path.)  Enter "Sample" when
prompted with the program name and enter "N" to writing only
selected program files.  After the program files are created you
may quit out of FoxView and run the program files by entering "DO
Sample" from within FoxBASE+.

COMPILATION:  For people new to FOXBASE+, the best performance is
achieved through compilation of the programs.  If, for instance,
your program were named Maillist.prg, it is possible to compile
all files produced by the MSA_1 templates by entering--

				foxpcomp mai*.prg

The new program files will be have a "fox" extension.  For
security, encryption is performed when the -e option is invoked.

				foxpcomp -e mai*.prg

For further information try reading the manual!  Warning: this
may be considered an unnatural act in many states and will
subject you to fines and ridicule by your peers.


PROGRAM NOTES

Menus:  I have made extensive use of menus in the system.
There may be an occasion when a menu may block information
already on the screen; simply press <Esc> to make the menu
disappear.  Pressing any key will pop it back.

ADD INS:  The menus have space for add-in applications.  If you
wish to include a custom report as a menu option, two files must
be altered--{fileprefix}_mbar and {fileprefix}_repo.  The menu
bar program ({fileprefix}_mbar.prg) must have the name entered. 
Also, the case statement of the report section (Case Choice_Y =
4) must have the program name inserted.  The same process is
followed should any of the pull-down menus be changed.


SECTION DETAILS

Logo section:
	You will need to modify this template for your own sign-on.
It can be eliminated by removing the call for it from
MSAMAIN.INC.

Install section:

	The information placed in this section is stored in a memvar
file {fileprefix}_inst.mem.  Each time the program is executed
this file is used to configure the program to the following
values:

	Company name:  Used for customizing the promptbar.  Company
extension code at present is not used and may be left blank.

	Printer codes:  Allows the system to be configured to any
printer.  These codes are used in the report and label section. 
Check the FoxBASE+ and printer manuals for more information.

     Colors:  A very personal matter.  The sample system supplied
has a screen and CFG file set using blue as a backround with
white as a foreground color.

     Data Drive:  This is used to set the Default drive where the
dbf files reside.

     Backup and Restore:  The program request the names of either
a program or batch file which will run backup/restore operations.
If the computer does not have a specialized backup system (such
as a tape system), use a word processor to create two simple BAT
files. 

                        Backup#.BAT
echo off
cls
echo :
echo :
echo :
echo   WARNING ! Make sure you have enough formatted diskettes
ready.
echo :
echo                  to abort press (CNTL) C
echo :
pause
echo   Copying Files.  Please wait...'
backup c:\[sub directory]\*.dbf a:
cls
echo   Files Copied
echo :
echo :
pause
cls
echo on

                        Restore#.BAT
echo off
cls
echo :
echo :
echo :
echo   WARNING ! Make sure you have your backup diskettes ready.
echo :      The backup files will write over the hard disk
files!!
echo :
echo                  to abort press (CNTL) C
echo :
pause
echo   Copying Files.  Please wait...'
RESTORE A: C:\[subdirectory]\*.DBF
cls
echo   Files Copied
echo :
echo :
pause
cls
echo on


The program assumes that the path has been set to the DOS
subdirectory so that BACKUP and RESTORE commands are available. 
Consult your DOS manual on these commands.

     Typical Problems: If the memory file is damaged so that the
install section is not operating properly, quit from the program
and erase the memory file ({fileprefix}_inst.mem ).  Then
re-start the program and the system will automatically create a
new file.


Condition section:

To de-select a filter, use "Select" option from menu and enter
0 for the record number.

Notes/headings allows you to comment your filters and these
notes are printed on the headings of reports when run.

If the conditions file {fileprefix}_COND.DBF is damaged, it
is necessary to leave the system and erase the conditions file.
Once the system is restarted, a new file will automatically be
created.  However, all of the filter conditions will need to be
re-entered.

Report section:

The deleted records report lists to the screen all records
which are marked for deletion.  When the Index and Pack option is
chosen, all records shown will be removed from the file.  

The Run Reports option will give a directory of all FRM files
which begin with the {fileprefix} of the program (i.e. the first
three letters of the program.

Several problems can occur in the report section because it is
dependent on the data in two other files besides the report
form itself.  First, if the conditions file {fileprefix}_COND.DBF
is damaged, trying to use a condition could lead to error
messages.  See condition section for details.  Second, should the
print section not operate properly, check the printer codes in
the install section of the program.  Re-read the above notes on
the "Install" section should you encounter problems with entering
the print codes.

Refer to the "ADD-IN" section under "General Notes" (above) to
change the add-in program listing.

Label (same procedure as Report)

Index and Pack Section:

It is recommended that you first run the deleted records report
which will list on the screen all records (if any) marked for
deletion.  Once the reindex is run, the records are gone forever
--so caution is recommended.  When you are in browse or
edit, the <Del> key is used to change the status of the record
(i.e. deleted on or off).



                        TECHNICAL SUPPORT

    TECHNICAL SUPPORT IS AVAILABLE FOR REGISTERED USERS ONLY!



            OTHER PRODUCTS FROM MICROSEARCH ASSOCIATES

MicroSearch Associates is a consulting firm that specializes in
database management systems.  In addition to consulting,
MicroSearch Associates also engages in contract programming.


                           REGISTRATION


All users registered with the developer will automatically
receive notification of the next release.  If you use this
template, its code, or a modified version of it, please print a
copy of the registration form, complete it, and mail the form
along with a registration fee of $35.00 to:


                      MicroSearch Associates
                       520 S.E. 44th Avenue
                        Ocala, FL   32671
 
You may print the registration form by using either PRINT.COM (a
DOS utility), your text processor, or use the DOS COPY command as
follows:

              A>COPY SIGNUP.TXT PRN <ENTER>


                        SOFTWARE AGREEMENT

License:  Registration grants the user unlimited usage of the
templates for the production of program code on one machine.
You may not use the software on more than one single machine
without the written consent of MicroSearch Associates even if you
own or lease all of them.

Site License:  Site License for unlimited usage of the templates
on more than one machine, or on a network, is available for
corporate accounts.

Ownership:  MicroSearch Associates retains title and ownership to
template code, templates and all routines and procedures produced
by the templates.

Restrictions:  You may not resell the templates, template code or
any portion thereof to third parties.  However, as a registered
user you are free to use, sell, or distribute any programs
produced by the templates.

Liabilities:  The product is provided "as is" without warranty of
any kind.  Further, MicroSearch does not warrant, guarantee, or
make any representations regarding the use of these programs.  No
suitability for any particular use is claimed, since you are free
to test the product and determine its merits on your own before
registration.

Updates:  MicroSearch Associates may create, from time to time,
updated versions of the software Templates.  These will be made
available to registered users who have paid the update fee.

Warning:  Distribution or use of programs (or any portion)
produced by these templates without registration constitutes
theft.

<<end>>

<<* EOF() MSAREAD.INC *>>
